/**************************************************************************
***    
*** Copyright (c) 1995-2000 Regents of the University of California,
***               Andrew E. Caldwell, Andrew B. Kahng and Igor L. Markov
*** Copyright (c) 2000-2005 Regents of the University of Michigan,
***               Saurabh N. Adya, Jarrod A. Roy, David A. Papa and
***               Igor L. Markov
***
***  Contact author(s): abk@cs.ucsd.edu, imarkov@umich.edu
***  Original Affiliation:   UCLA, Computer Science Department,
***                          Los Angeles, CA 90095-1596 USA
***
***  Permission is hereby granted, free of charge, to any person obtaining 
***  a copy of this software and associated documentation files (the
***  "Software"), to deal in the Software without restriction, including
***  without limitation 
***  the rights to use, copy, modify, merge, publish, distribute, sublicense, 
***  and/or sell copies of the Software, and to permit persons to whom the 
***  Software is furnished to do so, subject to the following conditions:
***
***  The above copyright notice and this permission notice shall be included
***  in all copies or substantial portions of the Software.
***
*** THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, 
*** EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
*** OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. 
*** IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
*** CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT
*** OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR
*** THE USE OR OTHER DEALINGS IN THE SOFTWARE.
***
***
***************************************************************************/


//! author=" Devendra"
/* This file contains all the declarations of functions for ABKCommon */

unsigned abkGcd (unsigned, unsigned);
unsigned abkGcd (const std::vector<unsigned>&);
unsigned abkFactorial(unsigned n);

//: Be true if the two string are same
class CompareNameEqual
{
  public:

    CompareNameEqual(){}
    bool operator()(const char* s1, const char* s2) const
                   { return strcmp(s1, s2) == 0; }
};

inline float float_abs(const float f)
{
  const unsigned mask = ~(1U << 31);
  union { float f; unsigned u; } ff;
  ff.f = f;
  ff.u = ff.u & mask;
  return ff.f;
}

inline double double_abs(const double d)
{
// only here because the compiler throws a fit
// about the long long with -pedantic and -Wall
#ifdef ABKDEBUG
  return (d < 0) ? -d : d;
#else
  const unsigned long long mask = ~(1ULL << 63);
  union { double d; unsigned long long u; } dd;
  dd.d = d;
  dd.u = dd.u & mask;
  return dd.d;
#endif
}
